# SoleLogics.jl -- Computational logic in Julia

[![Stable](https://img.shields.io/badge/docs-stable-blue.svg)](https://aclai-lab.github.io/SoleLogics.jl/stable)
[![Dev](https://img.shields.io/badge/docs-dev-blue.svg)](https://aclai-lab.github.io/SoleLogics.jl/dev)
[![Build Status](https://api.cirrus-ci.com/github/aclai-lab/SoleLogics.jl.svg)](https://cirrus-ci.com/github/aclai-lab/SoleLogics.jl)
[![Coverage](https://codecov.io/gh/aclai-lab/SoleLogics.jl/branch/master/graph/badge.svg)](https://codecov.io/gh/aclai-lab/SoleLogics.jl)
<!-- [![Coverage](https://coveralls.io/repos/github/aclai-lab/SoleLogics.jl/badge.svg?branch=master)](https://coveralls.io/github/aclai-lab/SoleLogics.jl?branch=master) -->

## In a nutshell

SoleLogics.jl provides a fresh codebase for computational logic, featuring easy manipulation of:
- Propositional and (multi)modal logics (propositions, logical constants, alphabet, grammars, crisp/fuzzy algebras);
- Logical formulas (random generation, parsing, minimization);
- Logical interpretations (e.g., propositional valuations, Kripke structures);
- Algorithms for *model checking*, that is, checking that a formula is satisfied by an interpretation.

SoleLogics.jl lays the logical foundations for [Sole.jl](https://github.com/aclai-lab/Sole.jl), an open-source framework for symbolic machine learning.

# Usage

## Installation

## Generating random formulas

## Generating random interpretations

## Model checking


# About
